package ihm;
import logique.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
public class MyDefaultStyleDocument extends DefaultStyledDocument implements  DocumentListener

          
{
ListeTag _tag;
MainFrame _master;
MyDefaultStyleDocument(ListeTag t,MainFrame master) 
{
super();
_tag=t;
_master=master;
}
public void setListeTag(ListeTag lt)
 {
 _tag=lt;

 }       
MyDefaultStyleDocument(AbstractDocument.Content c, StyleContext styles,ListeTag t,MainFrame master) 
{
super(c,styles);
_tag=t;
_master=master;
addDocumentListener(this);
}
          
MyDefaultStyleDocument(StyleContext styles,ListeTag t,MainFrame master)  
{
super(styles);
_tag=t;
_master=master;
addDocumentListener(this);
}
public void changedUpdate(DocumentEvent e) 
{ 	
}

public void insertUpdate(DocumentEvent e) 
{
long profile=System.currentTimeMillis();
    //  System.err.println("insertUpdate(DocumentEvent)"+e);
      int taille=e.getLength(); 
      int where=e.getOffset();
       _tag.AddText(where,taille,getNbLigne(where,where+taille));
      
	  _master.UpDateTag();
}
public  void removeUpdate(DocumentEvent e) 
{  	long profile=System.currentTimeMillis();
     //System.err.println("removeUpdate"+e);
      int taille=e.getLength(); 
      int where=e.getOffset();
      _tag.RemoveText(where,taille,getNbLigne(where,where+taille));
      
        _master.UpDateListe();
}
 


public void ApplyForAll(MutableAttributeSet attr)
{
if (Thread.currentThread() == getCurrentWriter()) {/*System.err.println("problem\n");*/writeUnlock();}
else {/*System.err.println("no problem\n");*/}
writeLock();

Element[] routelem=getRootElements();
for (int i=0;i<routelem.length;i++)
{
ElementIterator it = new ElementIterator(routelem[i]);
   		
		      
Element elem; 
while ((elem = it.next()) != null) {
	
	MutableAttributeSet oldattr = (MutableAttributeSet) elem.getAttributes();
   	oldattr.removeAttributes(oldattr);
  	oldattr.addAttributes(attr) ;
           
	} 
	}

DefaultDocumentEvent e = new DefaultDocumentEvent(0, getLength(),
					      DocumentEvent.EventType.CHANGE);
	e.end();
	fireChangedUpdate(e);
	writeUnlock();
}

public boolean  setAttributeSet(MutableAttributeSet attrM,int debut,int fin) 
{

   long profile=System.currentTimeMillis();	
//System.out.println("setAttributeSet(MutableAttributSet debut fin)");
    if ( debut != fin)
    {
    setCharacterAttributes(debut, fin - debut, attrM, false);
    //System.err.println("End of setAttributeSet(MutableAttributSet debut fin)"+(System.currentTimeMillis()-profile));

        return true;

} 

  return false;
  
}

 
/** 
 * gere l'ajout dans le document 
 */
protected void insertUpdate(AbstractDocument.DefaultDocumentEvent chng,
                            AttributeSet attr)
      {super.insertUpdate(chng,attr);
     
	//System.err.println("End of insertUpdate(DocumentEvent)"+(System.currentTimeMillis()-profile));
	
      }
/**
 * gere le retrait de caractere dans le document 
 */
protected void removeUpdate(AbstractDocument.DefaultDocumentEvent chng)

       {
       	super.removeUpdate(chng);
     
        //System.err.println("End of insertUpdate(DocumentEvent)"+(System.currentTimeMillis()-profile));
	
       


}
public void setTag(ListeTag t){_tag=t;}
 /**
   * rend le nombre de ligne entre le caractere debut et le caractere fin"
   */
    public int getNbLigne(int debut,int fin)
    {
    
     int un=getLigne(debut);
     int deux=getLigne(fin);
     if (un>deux) return (un-deux); else return (deux-un);
    
}



/**
 * donne le numero de la ligne du charactere l
 */
   public int getLigne(int l)
  {
  	int index=0;

	Element element=getCharacterElement(l);
	
	index=getDefaultRootElement().getElementIndex(l) ;
          
  return index;
  }
}