package logique;
import java.util.*;
import java.io.*;
import javax.swing.text.SimpleAttributeSet;
import org.xml.sax.*;
public class CoupleHash implements XmlSerialisable , Comparable

{
public String baliseName;
public Style style;
public int numero;
public CoupleHash(){}
public CoupleHash(String s,Style st){this(s,st,0);}
public CoupleHash(String s,Style st,int nb){baliseName=s;style=st;numero=nb;}
public String getXMLName(){return "couplehash";}
public  void WriteXML(PrintWriter out)
{
out.write("<couplehash name=\""+baliseName+"\">\n");
style.WriteXML(out);
out.write("</couplehash>");
}
 
public int compareTo(Object o) 
{
return baliseName.compareTo(((CoupleHash)o).baliseName);
/*CoupleHash tmp=(CoupleHash) o;
if (tmp.numero>numero) return 1;
if (tmp.numero<numero) return -1;
return 0;*/

}
           

public void lectXML(Attributes attributes,Vector construct)
{
System.err.println("CoupleHash::lectXML"+attributes+"taille:"+attributes.getLength()+"nom"+attributes.getValue(0));
baliseName=attributes.getValue("name");
System.err.println("BaliseName"+attributes.getValue("name"));
style=(Style)construct.get(0);
}
public String toString(){return (baliseName+style.toString());}
public Object clone()
{
CoupleHash result=new CoupleHash(new String(baliseName),(Style)style.clone(),numero);
return result;
}

}