package style;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import gnu.regexp.*;
import dialogtool.*;
import myEvent.*;
import logique.*;
public class SemantiqueStylePanel extends JPanel  
{
	 transient SemantiquePanelListener listener;
	JLabel _label;
	int m_option;
	JRadioButton _do_nothing;
	JRadioButton _do_it;
	JButton cancel;
	JButton ok;
	JRadioButton _arround_balise;
	JRadioButton _arround_paragraphe;
	JRadioButton _begin_end_document;
	JTextField _regexp1;
	JTextField _regexp2;
	JLabel _tag_debut;
	JLabel _tag_fin;
	JRadioButton _avant_debut;
	JRadioButton _avant_fin;
	JRadioButton _apres_debut;
	JRadioButton _apres_fin;
	JRadioButton _use_regexp;
	Alert _alert;
	JPanel _panel;
	 JPanel regexp;
public int getStatus(){return m_option;}
public boolean getDoSomething()
{
	//System.err.println("GetDOSomething():"+_do_it.isSelected());
	return _do_it.isSelected();

}
public boolean getArroundBalise(){return _arround_balise.isSelected();}
public boolean getArroundParagraphe(){return _arround_paragraphe.isSelected();}
public boolean getArroundDocument(){return _begin_end_document.isSelected();}
public boolean getArroundRegexp(){return _use_regexp.isSelected();}
public boolean getAvantFin(){return _avant_fin.isSelected();}
public boolean getAvantDebut(){return _avant_debut.isSelected();}
public String getRegExp1(){return _regexp1.getText();}
public String  getRegExp2(){return _regexp2.getText();}

public void setAttributes(SemantiqueRule rule)
{
boolean dob=rule.doSomething();
if (!dob)
	{
	 _do_nothing.setSelected(true);
	
	_do_it.setSelected(false);
	_arround_balise.setVisible(false);
	_arround_paragraphe.setVisible(false);
	_begin_end_document.setVisible(false);
	regexp.setVisible(false);
	_use_regexp.setVisible(false);
}
	else
	{
	_do_nothing.setSelected(false);
       	_do_it.setSelected(true);
	_arround_balise.setVisible(true);
	_arround_paragraphe.setVisible(true);
	_begin_end_document.setVisible(true);
	_arround_balise.setSelected(rule.autourBalise());
	_arround_paragraphe.setSelected(rule.autourParagraphe());
	_begin_end_document.setSelected(rule.autourDocument());
	_use_regexp.setVisible(true);
	boolean r=rule.autourRegExp();
	if (r)
		{
			regexp.setVisible(true);
			_avant_debut.setSelected(rule.AvantDebut());
			_apres_debut.setSelected(!rule.AvantDebut());
			_avant_fin.setSelected(rule.AvantFin());
			_apres_fin.setSelected(!rule.AvantFin());
			_regexp1.setText(rule.RegExp1());
			_regexp2.setText(rule.RegExp2());
			
		
		}else {regexp.setVisible(false);}
	_use_regexp.setSelected(r);
	}

}
public SemantiqueStylePanel()
{super();
_panel=new JPanel(new GridLayout(4,1));
_alert=new Alert();
JPanel option=new JPanel(new GridLayout(4,1));
JPanel general=new JPanel(new GridLayout(3,1));
  regexp=new JPanel(new GridLayout(4,1));
JPanel regexp_debut=new JPanel(new FlowLayout());
JPanel regexp_fin=new JPanel(new FlowLayout());
_tag_debut=new JLabel("Tag de dbut:");
_tag_fin=new JLabel("Tag de fin:");
 _avant_debut=new JRadioButton("Avant",true);
 _avant_debut.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _avant_fin.setSelected(false);
      }});
 _avant_fin=new JRadioButton("Apres",false);
 _avant_fin.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _avant_debut.setSelected(false);
      }});
_apres_debut=new JRadioButton("Avant",true);
_apres_debut.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _apres_fin.setSelected(false);
      }});
_apres_fin=new JRadioButton("Apres",false);
_apres_fin.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _apres_debut.setSelected(false);
      }});
_regexp1=new JTextField(10);
_regexp2=new JTextField(10);
regexp_debut.add(_avant_debut);
regexp_debut.add(_avant_fin);
regexp_debut.add(_regexp1);
regexp_fin.add(_apres_debut);
regexp_fin.add(_apres_fin);
regexp_fin.add(_regexp2);
regexp.add(_tag_debut);
regexp.add(regexp_debut);
regexp.add(_tag_fin);
regexp.add(regexp_fin);

_label=new JLabel("Si la balise de niveau immediatement superieur est manquante:");
_do_nothing=new JRadioButton("Ne rien faire",true);
_do_it=new JRadioButton("Inserer[Interactivement/Automatiquement] cette balise",false);
_use_regexp=new JRadioButton("En utilisant l'expression rguliere",false);

_arround_balise=new JRadioButton("Autour de la balise courante",true);
_arround_paragraphe=new JRadioButton("Autour du paragraphe courant",false);
_begin_end_document=new JRadioButton("En debut et en fin de document",false);
_arround_balise.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _arround_paragraphe.setSelected(false);
       _begin_end_document.setSelected(false);
       _use_regexp.setSelected(false);
        regexp.setVisible(false);
      
}});
_arround_paragraphe.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _arround_balise.setSelected(false);
       _begin_end_document.setSelected(false);
       _use_regexp.setSelected(false);
       regexp.setVisible(false);
      
}});
_begin_end_document.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _arround_balise.setSelected(false);
       _arround_paragraphe.setSelected(false);
      _use_regexp.setSelected(false);
        regexp.setVisible(false);
}});
_use_regexp.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _arround_balise.setSelected(false);
       _arround_paragraphe.setSelected(false);
      _begin_end_document.setSelected(false);
        regexp.setVisible(true);
      }});
_arround_balise.setVisible(false);
_arround_paragraphe.setVisible(false);
_begin_end_document.setVisible(false);
_use_regexp.setVisible(false);
  regexp.setVisible(false);

_do_nothing.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _do_it.setSelected(false);
	_arround_balise.setVisible(false);
_arround_paragraphe.setVisible(false);
_begin_end_document.setVisible(false);
_use_regexp.setVisible(false);
  regexp.setVisible(false);
      }});
_do_it.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       _do_nothing.setSelected(false);
       _do_it.setSelected(true);
       _arround_balise.setVisible(true);
_arround_paragraphe.setVisible(true);
_begin_end_document.setVisible(true);
_use_regexp.setVisible(true);
if (_use_regexp.isSelected()) regexp.setVisible(true);
      }});
ok=new JButton("Apply this rule");
ok.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
      System.out.println("_useREGEXP"+_use_regexp.isSelected());
      if (_use_regexp.isSelected())
      { m_option = JOptionPane.OK_OPTION;
      try
      { String r1=_regexp1.getText();
      	//System.err.println("REGEXP1="+r1);
        RE stub=new RE(r1,0,RESyntax.RE_SYNTAX_EMACS);
      }
      catch (REException re){
      	//System.err.println(re);
      	_alert.alert(re.getMessage());
      _alert.setVisible(true);m_option = JOptionPane.CANCEL_OPTION;}
      catch (NullPointerException d) {_alert.alert("L expression reguliere de Tag de debut est vide");_alert.setVisible(true);m_option = JOptionPane.CANCEL_OPTION;}
      try
      { String r2=_regexp2.getText();
         	//System.err.println("REGEXP1="+r2);
        RE stub2=new RE(r2,0,RESyntax.RE_SYNTAX_EMACS);
      }
      catch (REException re2){_alert.alert(re2.getMessage());_alert.setVisible(true);m_option = JOptionPane.CANCEL_OPTION;}
      catch (NullPointerException d2) {_alert.alert("L expression reguliere de Tag de debut est vide");_alert.setVisible(true);m_option = JOptionPane.CANCEL_OPTION;}
       


} else m_option = JOptionPane.OK_OPTION;
updatePreview();
  
      }});

JPanel ok_cancel=new JPanel(new FlowLayout());
general.add(_label);
general.add(_do_nothing);
general.add(_do_it);
option.add(_arround_balise);
option.add(_arround_paragraphe);
option.add(_begin_end_document);
option.add(_use_regexp);
ok_cancel.add(ok);

_panel.add(general);
_panel.add(option);
_panel.add(regexp);
_panel.add(ok_cancel);
setSize(new Dimension(400,440));
add(_panel);
}
 protected void updatePreview()
  {  SemantiquePanelEvent bd ;
  SemantiqueRule rule;
  if (!getDoSomething())
 { rule=new SemantiqueRule();
 rule.setSomething(false);
 }
  else {rule=new SemantiqueRule(getArroundBalise(),getArroundParagraphe(), getArroundDocument(),getArroundRegexp(),getAvantFin(),getAvantDebut(),getRegExp1(), getRegExp2());
  rule.setSomething(true);
 }
 bd=new SemantiquePanelEvent(this,rule);
            Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd);
 	}
 public synchronized void addSemantiquePanelListener(SemantiquePanelListener l)
        throws TooManyListenersException {
            if (listener != null) {
                throw new TooManyListenersException();
            }
            listener = l;
        }

    // Override processEvent() to handle new event type
    protected void processEvent(AWTEvent evt) {
        if (evt instanceof SemantiquePanelEvent) {
            processSemantiquePanelEvent((SemantiquePanelEvent)evt);
            return;
        }
        super.processEvent(evt);
    }

    // Method for processing new event type
    protected void processSemantiquePanelEvent(SemantiquePanelEvent evt) {
        if (listener != null) {
            listener.SemantiqueChanged(evt);
        }
    }

	
}