package xml;
import logique.*;
import org.xml.sax.*;
import org.xml.sax.ext.DeclHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import org.xml.sax.helpers.AttributesImpl;

public class GeneralReader  extends DefaultHandler 
{
private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";
private Vector object_serialisable;
private Stack construct;
private Stack attribute;
private XmlSerialisable resultat;
public XmlSerialisable getResultat(){return resultat;}
public void startDocument() 
{
	resultat=null;
	construct=new Stack();
attribute=new Stack();
}



public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes) 
{
	
          
AttributesImpl at=new AttributesImpl(attributes) ;
attribute.push(at);
Stack tmp=new Stack();
construct.add(tmp);
System.err.println(localName+" "+at);
}
public void endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName) 
{
try{
//System.err.println(localName);
XmlSerialisable ser=search(localName);
//System.err.println("trouve le constructeur par default");
Constructor c=findDefault(ser.getClass());
//System.err.println("Appel le constructeur par default");
XmlSerialisable nouveaux=(XmlSerialisable)c.newInstance(null);
Stack s=(Stack)construct.pop();
Vector args=new Vector();
while (!s.empty()) args.add(0,s.pop());
//System.err.println("empile les arguments");
Attributes attr=(Attributes) attribute.pop();
//System.err.println("lance la lecture");
nouveaux.lectXML(attr,args);
//System.err.println(nouveaux);
if (construct.empty()) // c est finie 
resultat=nouveaux;
else 
{Stack tmp=(Stack)construct.peek();
tmp.push(nouveaux);
}
}
catch (Exception e){System.err.println(e);}                     
}
public Constructor findDefault(Class c)
{
Constructor[] listeconstruc=c.getConstructors();
for (int i=0;i<listeconstruc.length;i++) if (listeconstruc[i].getParameterTypes().length==0) return listeconstruc[i];
return null;
}
public XmlSerialisable search(String s)
{
for (int i=0;i<object_serialisable.size();i++)
{
XmlSerialisable ser=(XmlSerialisable)object_serialisable.get(i);
//System.err.println(ser.getXMLName()+"=="+s);
if (ser.getXMLName().equals(s)) return ser;
}
return null;
}
public GeneralReader()
{
object_serialisable=new Vector();
construct=new Stack();
attribute=new Stack();
}
public void AddSerialisable(XmlSerialisable serialisable)
{
object_serialisable.add(serialisable);
}
public void lect(FileReader f) throws Exception
{
  SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  
parser.setContentHandler (this);
     parser.parse(new InputSource(f));
    
} 
public static void main(String args[]) 
{
 try{ SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  GeneralReader lo = new GeneralReader();
  lo.AddSerialisable(new GraphicStyle());
    lo.AddSerialisable(new logique.Style());
      lo.AddSerialisable(new SemantiqueRule());
parser.setContentHandler (lo);
     parser.parse(new InputSource(new FileReader(args[0])));
    }catch (Exception q) {System.err.println(q);}
     
}
           
}