package ihm;
import logique.*;
import xml.*;
import myEvent.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.BevelBorder;


import javax.swing.border.*;

class StyleEditBalise extends JScrollPane
{
	private ListeBalise _liste_balise;
	private JViewport _window;
	private Vector _rtflabel;
	public static String default_dtd="Default.dtd"; 
	transient StyleEditBaliseListener listener;

/************* EVENEMENTIEL ***************/
public synchronized void addStyleEditBaliseListener(StyleEditBaliseListener l)
        throws TooManyListenersException {
            if (listener != null) {
                throw new TooManyListenersException();
            }
            listener = l;
        }

    // Override processEvent() to handle new event type
    protected void processEvent(AWTEvent evt) {
        if (evt instanceof StyleEditBaliseEvent) {
            processStyleEditBaliseEvent((StyleEditBaliseEvent)evt);
            return;
        }
        super.processEvent(evt);
    }

    // Method for processing new event type
    protected void processStyleEditBaliseEvent(StyleEditBaliseEvent evt) {
        if (listener != null) {
            listener.BaliseInserted(evt);
        }
    }
    public void changed(Balise b){
    	StyleEditBaliseEvent bd = new StyleEditBaliseEvent(this, b);
          Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd);
        }
/************* EVENEMENTIEL ***************/
class RTFLabel 
{
private Balise balise;
private NTextField _textfield;

public class NTextField extends JTextPane  implements MouseListener
{
protected Balise _balise;
protected StyleEditBalise _master;
  protected Border m_raised;
  protected Border m_lowered;
  protected Border m_inactive;
  protected boolean _actif;

public NTextField(Balise balise,StyleEditBalise master)
{
super();
_balise=balise;
_master=master;
  m_raised = new BevelBorder(BevelBorder.RAISED);
    m_lowered = new BevelBorder(BevelBorder.LOWERED);
    m_inactive = new EmptyBorder(2, 2, 2, 2);
    
 setBorder(m_inactive);
 addMouseListener(this);
    setRequestFocusEnabled(false);
  _actif=true;
 
}
public void setEnabled(boolean enable)
{
super.setEnabled(enable);
if (enable) setBackground(new Color(255,255,255));
else setBackground(new Color(128,128,128));

}
public void setActif(boolean actif)
{
_actif=actif;
if (!_actif) setEnabled(false); //setBackground(new Color(255,0,0));
else setEnabled(true);//setBackground(new Color(255,255,255));
}
public void setActif(Vector v)
{
String name=_balise.getName();
if (!v.contains(name)) setActif(false);
}
public void mouseClicked(MouseEvent e){
      
System.out.println("StyleEditBalise::mouseClicked");
if (_actif) _master.changed(_balise);

   
}
        public void mousePressed(MouseEvent e) {
   if (_actif) setBorder(m_lowered);
  }
/** met a jour le bord inactif du bouton 
 * si la souris est releve
 */
  public void mouseReleased(MouseEvent e) {
 if (_actif)   setBorder(m_inactive);
  }

  /** a surcharge , effet si le bouton est clicke
   */
 
  public void mouseEntered(MouseEvent e) {
 if (_actif)   setBorder(m_raised);
  }

  public void mouseExited(MouseEvent e) {
  if (_actif)  setBorder(m_inactive);
  }


}
public RTFLabel(Balise b,StyleEditBalise master,JPanel p_name)
{
_textfield=new NTextField(b,master);
StyledEditorKit m_kit = new StyledEditorKit();
 _textfield.setEditorKit(m_kit);
balise=b;


_textfield.setDocument(new DefaultStyledDocument(new StyleContext()));
_textfield.setDoubleBuffered(true);
_textfield.setEditable(false);
try
{_textfield.getDocument().insertString(0,b.toString(),b.getAttribut());
}catch (Exception f) {System.out.println(f);}


p_name.add(_textfield);



}
public void setActif(boolean actif) {_textfield.setActif(actif);}
public void setActif(Vector v ) {_textfield.setActif(v);}

}	
public void GereDefault()
{	try
	{FileReader fichier=new FileReader(StyleEditBalise.default_dtd);
	
	String filename=new String();
	int c=0;
	char [] v=new char[1];
	while((c=fichier.read())!=-1)
	{
	v[0]=(char)c;
	filename=filename.concat(new String(v));
	
}
	fichier.close();
	//_master.LectDTD(filename);
	}
	catch (Exception b){};
}
public StyleEditBalise()
{
super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	    
	setSize(600, 400);
	_window=new JViewport();
setViewportView(_window);	
 _rtflabel=new Vector(10,10);
	 setVisible(true);


	 
}

public void UpDate(ListeBalise liste_balise)
{
System.out.println(liste_balise);
JPanel checking = new JPanel(new BorderLayout());
JPanel p_name = new JPanel(new GridLayout(liste_balise.size(), 1, 10, 2));

checking.setBorder(new TitledBorder(new EtchedBorder(), "Style des Balises"));
for (int j=0;j<liste_balise.size();j++) 
{
	Balise b=(Balise)liste_balise.get(j);
	RTFLabel label=new RTFLabel(b,this,p_name);
	_rtflabel.add(label);
	
}
checking.add(p_name, BorderLayout.WEST);

_window.add(checking);
  
  setVisible(false);
  setVisible(true);
}
public void Activ(Vector s)
{
for (int i=0;i<_rtflabel.size();i++) 
{
((RTFLabel)_rtflabel.get(i)).setActif(s);
}
}
public void ActivAll(boolean b)
{
for (int i=0;i<_rtflabel.size();i++) 
{
((RTFLabel)_rtflabel.get(i)).setActif(b);
}
}
public void Activate(Balise b){}
}
