package logique;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import org.xml.sax.*;

public class Style implements XmlSerialisable
{
protected GraphicStyle _styleGraphics;
protected SemantiqueRule _styleSemantique;
public Style(){
	_styleGraphics=new GraphicStyle();
	_styleSemantique=new SemantiqueRule();
}
public String getXMLName(){return "Style";}
public  void WriteXML(PrintWriter out)
{
out.print("<Style>");
_styleGraphics.WriteXML(out);
_styleSemantique.WriteXML(out);
out.print("</Style>\n");
out.flush();
}
public Object clone()
{
Style result=new Style();
result._styleGraphics=(GraphicStyle)_styleGraphics.clone();
result._styleSemantique=(SemantiqueRule)_styleSemantique.clone();
return result;
}
public void lectXML(Attributes attributes,Vector construct) 
{
	XmlSerialisable un=(XmlSerialisable) construct.get(0);
	XmlSerialisable deux=(XmlSerialisable) construct.get(1);
	
	_styleGraphics=(GraphicStyle) un;
	_styleSemantique=(SemantiqueRule) deux;

}
public  GraphicStyle getGraphicStyle(){return _styleGraphics;}
public  SemantiqueRule getSemantiqueStyle(){return _styleSemantique;}
public void setGraphicStyle(GraphicStyle g){_styleGraphics=g;}
public void setSemantiqueStyle(SemantiqueRule g){_styleSemantique=g;}
}