package style;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import myEvent.*;
import logique.*;
public class StylePanel extends JPanel implements FontPanelListener,SemantiquePanelListener
{
JTabbedPane _tabbedPane;
FontDialog _fontDialog;
SemantiqueStylePanel _semDialog;
FontPanelListener _listener;
SemantiquePanelListener _listenerSem;
public StylePanel()
{
super();
_tabbedPane=new JTabbedPane();
_fontDialog=new FontDialog();System.err.println("trace");
_semDialog=new SemantiqueStylePanel();
String []  m_fontNames = GraphicsEnvironment.
      getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
   String []  m_fontSizes = new  String[] {"8", "9", "10", "11", "12", "14",
      "16", "18", "20", "22", "24", "26", "28", "36", "48", "72"};
_fontDialog.init(m_fontNames,m_fontSizes);
_tabbedPane.add("GraphicsStyle",_fontDialog);
_tabbedPane.add("SemantiqueStyle",_semDialog);
add(_tabbedPane);

try
{
	_fontDialog.addFontPanelListener(this);
	_semDialog.addSemantiquePanelListener(this);
}
catch(Exception e){System.err.println(e);}
}
public void set(String s,logique.Style attr)
{
	SimpleAttributeSet at=attr.getGraphicStyle().getAttributes();
_fontDialog.set_example(s,at);
_fontDialog.setAttributes(at);
_semDialog.setAttributes(attr.getSemantiqueStyle());
}
public void addFontPanelListener(FontPanelListener listener)
{
_listener=listener;
}
public void addSemantiquePanelListener(SemantiquePanelListener listener)
{
_listenerSem=listener;
}
    public void FontChanged(FontPanelEvent evt)
    {
    	
    System.err.println(evt);	
    _listener.FontChanged(evt);
    
}
public void SemantiqueChanged(SemantiquePanelEvent evt)
 {
    	
    System.err.println(evt);	
    _listenerSem.SemantiqueChanged(evt);
    
}

 public static void main(String [] args)
 {
 JFrame h=new JFrame();
 h.getContentPane().add(new StylePanel());
 h.setVisible(true);
 }         
}