package xml;
import logique.*;
import org.xml.sax.*;
import org.xml.sax.ext.DeclHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import gnu.regexp.*;
import org.xml.sax.helpers.AttributesImpl;
/**
 * Permet de faire la lecture d'un document sauvegarder au format XML
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class DefaultHandlerLoadXml  extends DefaultHandler 
{
private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";
private    String _doc;

private ListeBalise _listeBalise;
private ListeTag _listeTag;
private DTDReader _dtdReader;
private String _dtdfile;

public ListeTag getListeTag(){return _listeTag;}
public ListeBalise getListeBalise(){return _listeBalise;}
public String getDocument(){return _doc;}
public String getDtdFileName(){return _dtdfile;}

public class CoupleBalise
{
String my_name;
boolean debut;
Attributes attrib;
int _place;
int _ligne;
public CoupleBalise(String s,boolean b,int place,int ligne)
{
my_name=new String (s);
debut=b;
_place=place;_ligne=ligne;
}
public CoupleBalise(String s,Attributes attr,boolean b,int place,int ligne)
{
this(s,b,place,ligne);
/*my_name=new String (s);
debut=b;*/
attrib=attr;

}
 

public String toString(){return new String(my_name+"("+debut+" enplacement:"+_place+")");}
}
int _start=0;
public Vector rec;
public Vector reordonne(Vector v)
{
Vector result=new Vector(10,10);
while(v.size()!=0){
	//System.err.println(" boucle taille du vecteur:"+v.size());
for (int i=0;i<v.size()-1;i++){
	//System.err.println(v);
	/*System.err.println("taille du vecteur:"+v.size()+"i:"+i);*/

	CoupleBalise b1=(CoupleBalise)v.get(i);

CoupleBalise b2=(CoupleBalise)v.get(i+1);
if (b1.my_name.equals(b2.my_name) && b1.debut && !b2.debut)
	{	
	//System.err.println(b2.my_name);
	result.add(v.get(i));
	v.remove(i);
	result.add(v.get(i));
	v.remove(i);
	i=0;
	//System.err.println("taille du vecteur: if"+v.size());

	}
	
}
}
return result;
}
public void startDocument() 
{
rec=new Vector(10,10);
_doc=new String();
_dtdfile=new String();
}




public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes) 
{
 //  System.err.println("DOCUMENT"+_doc);
//System.err.println("start Element uri:"+uri+" localName:"+localName+" qName:"+qName);
if (!qName.equals("xmljava"))
rec.add(new CoupleBalise(qName,new AttributesImpl(attributes),true,_doc.length(),NbLigne()));
}
public void endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName) 
{
//System.err.println("end Element uri:"+namespaceURI+" localName:"+localName+" qName:"+qName); 
if (!qName.equals("xmljava"))
rec.add(new CoupleBalise(qName,false,_doc.length(),NbLigne()));
}
public int NbLigne()
{
int acc=0;
for (int i=0;i<_doc.length();i++)
{
if (_doc.charAt(i)=='\n') acc++;
}
return acc;
}  
public void characters(char[] ch, int start, int length) 
{
_start=start;
//System.err.println("DOCUMENT(start,lenght)"+_start+","+length+":"+new String(ch,start,length));
String tmp=new String(ch,start,length);
_doc=_doc.concat(new String(tmp));
 // System.out.println("DOCUMENTparser"+_doc);
  
}
public DefaultHandlerLoadXml()
{
_doc=new String("pilou");
}
public  String getDTD(FileReader f)
{String result=new String();
try{
RE reg=new RE("SYSTEM \"[^\"]*\"");
//System.err.println(reg);
String str=new String(reg.getMatch(f).toString());
int etat=0;
int size=str.length();
int index=0;
char c;

//System.err.println("A matcher "+str+"size:"+size);

for (;index<size;index++)
{
c=str.charAt(index);
if (c=='"' && etat==0) etat=1; else
if (c=='"' && etat==1) etat=2; else
if (etat==1) result=new String(result+new Character(c));

}


}
catch (Exception e){System.err.println(e);}
return result;

}
public void lect(FileReader f) throws Exception
{
  SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  _dtdReader =new DTDReader();
  
parser.setContentHandler (this);
     parser.parse(new InputSource(f));
    
} 
public void lect(String filename ) throws Exception
{
   SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
   parser.setFeature( "http://xml.org/sax/features/validation",
                                                false);
            parser.setFeature( "http://xml.org/sax/features/namespaces",
                                                false );
            parser.setFeature( "http://apache.org/xml/features/validation/schema",
                                                false );
            parser.setFeature( "http://apache.org/xml/features/validation/schema-full-checking",
                                                false );
             parser.setFeature("http://apache.org/xml/features/nonvalidating/load-dtd-grammar",false);
             
             parser.setFeature("http://apache.org/xml/features/continue-after-fatal-error",true);
            //  parser.setFeature("http://apache.org/xml/properties/schema/external-schemaLocation",true);
 parser.setContentHandler (this);
InputSource source=new InputSource(new FileReader(filename));
      parser.parse(source);
        
     Vector v=reordonne(rec);
    // System.err.println(v);
     _dtdReader=new DTDReader();
       _dtdfile=getDTD(new FileReader(filename));
       _dtdReader.parseDTD(_dtdfile);
   
     _listeBalise=_dtdReader.getData();
     _listeTag=new ListeTag();
     int taille=v.size();
        
     for (int i=0;i<taille;i=i+2)
     {
     Tag t;
     CoupleBalise c1=(CoupleBalise)v.get(i);
     CoupleBalise c2=(CoupleBalise)v.get(i+1);
     Balise b=_listeBalise.getBaliseByName(c1.my_name);
     t=new Tag(b,c1._place,c2._place,(c1._ligne+c2._ligne)/2);
     Attributes attr=c1.attrib;
     int taille_attrib=attr.getLength();
     System.err.println("Taille de l'attribut"+taille_attrib);
     for (int j=0;j<taille_attrib;j++){
     String att_name=attr.getQName(j);
     String att_value=attr.getValue(j);
     System.err.println("Tag"+c1.my_name+"("+att_name+","+att_value+")");
     t.setValue(att_name,att_value);
} 
	//System.err.println(t.getDebutStringBalise());
	_listeTag.add(t);
     }
     
   
    
} 
public static void main(String args[]) 
{
 try{  
 (new DefaultHandlerLoadXml()).lect(args[0]);
   
    }catch (Exception q) {System.err.println(q);}
     
}
           
}
           