package ihm;
import logique.*;
import xml.*;
import java.io.*;
/** La classe SimpleFIlete est une extension  <br>
 * de javax.swing.fileChooser.FileFilter <br>
 * elle a pour but de rendre plus simple l'initialisation <br>
 * de la classe
 */

public class SimpleFilter extends javax.swing.filechooser.FileFilter
{
  private String m_description = null;
  private String m_extension = null;
/** le constructeur prend en parametre l'extension
 * et la description du format , par exemple rtf, RtfDOcument
 * 
 */
  
  public SimpleFilter(String extension, String description) {
    m_description = description;
    m_extension = "."+extension.toLowerCase();
  }
/**
 * fonction d'acces pour la description 
 */
  public String getDescription() {
    return m_description;
  }
/** soit f un fichier , correspond til a l'extension passer en 
 * parametre du constructeur
 * 
 */
  public boolean accept(File f) {
    if (f == null) 
      return false;
    if (f.isDirectory())
      return true;
    return f.getName().toLowerCase().endsWith(m_extension);
  }
}