package style;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import myEvent.*;
import logique.*;
public class ChoiceBalisePanel extends JPanel 
{transient BaliseChoiceListener listener;
	protected JList dataList ;
	protected JScrollPane _scroll;
public ChoiceBalisePanel()
{
	super();
dataList=new JList();
_scroll=new JScrollPane(dataList,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED );


 MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
         String s=(String)dataList.getSelectedValue();
         if (s!=null) changed(s);
          }
     
 };
 dataList.addMouseListener(mouseListener);
 add(_scroll);
 //add(dataList);
}

public void setData(EnsembleStyle listData)
{
Vector v=listData.getBaliseName();
Object [] vv=v.toArray();
Arrays.sort(vv);
//v=new Vector(vv);
dataList.setListData(vv) ; 
dataList.setVisibleRowCount(vv.length);
Rectangle rec=getVisibleRect();
Dimension dim=dataList.getPreferredScrollableViewportSize();
System.err.println("RECTANGLE="+rec+" DIMENSION"+dim);
int taille_row=dim.height/vv.length;
int nb_row=rec.height/taille_row;
dataList.setVisibleRowCount(nb_row);
System.err.println("taille_row:"+taille_row+" nb_row:"+nb_row);


//setVisibleRowCount

}
  
  
   public synchronized void addBaliseChoiceListener(BaliseChoiceListener l)
        throws TooManyListenersException {
            if (listener != null) {
                throw new TooManyListenersException();
            }
            listener = l;
        }

    // Override processEvent() to handle new event type
    protected void processEvent(AWTEvent evt) {
        if (evt instanceof BaliseChoiceEvent) {
            processBaliseChoiceEvent((BaliseChoiceEvent)evt);
            return;
        }
        super.processEvent(evt);
    }

    // Method for processing new event type
    protected void processBaliseChoiceEvent(BaliseChoiceEvent evt) {
        if (listener != null) {
            listener.BaliseChoiceChanged(evt);
        }
    }
    public void changed(String s){
    	BaliseChoiceEvent bd = new BaliseChoiceEvent(this, s);
          Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd);
          }
          
}



  
 class MyCellRenderer extends JLabel implements ListCellRenderer {
     final static ImageIcon longIcon = new ImageIcon("long.gif");
     final static ImageIcon shortIcon = new ImageIcon("short.gif");

     // This is the only method defined by ListCellRenderer.
     // We just reconfigure the JLabel each time we're called.
     public MyCellRenderer(String s){super(s);}
     public Component getListCellRendererComponent(
       JList list,
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // the list and the cell have the focus
     {
         String s = value.toString();
         setText(s);
         setIcon((s.length() > 10) ? longIcon : shortIcon);
   	   if (isSelected) {
             setBackground(list.getSelectionBackground());
	       setForeground(list.getSelectionForeground());
	   }
         else {
	       setBackground(list.getBackground());
	       setForeground(list.getForeground());
	   }
	   setEnabled(list.isEnabled());
	   setFont(list.getFont());
         return this;
     }
 }

